import React, {useState} from 'react'
import Head from 'next/head'

import {Inter} from 'next/font/google'
import styles from '/styles/Home.module.css'
import Footer from "@/components/Footer/Footer";
import NavBar from "@/components/NavBar/NavBar";
import Link from "next/link";
import {JOIN_NEWSLETTER_API} from "@/constants";


const inter = Inter({subsets: ['latin']})

export default function Home() {

    const [emailInput, setEmailInput] = useState<string>('')
    const [message, setMessage] = useState<string>('')
    const [isError, setIsError] = useState<boolean>(false)

    const handleJoinNewsletter = async () => {
        try {
            const regex = new RegExp("[^@\\s]+@[^@\\s]+\\.[^@\\s]+")
            if (!regex.test(emailInput)) {
                setMessage("Error: invalid input, please use a valid email")
                setIsError(true)
                return
            }
            const res = await fetch(JOIN_NEWSLETTER_API, {
                method: 'POST',
                headers: {'Content-Type': 'application/json'},
                body: JSON.stringify({
                    lastName: emailInput,
                })
            })
            const msg = await res.json()
            if (msg.lastName) {
                setMessage(`Success: ${msg.lastName}`)
                setIsError(false)
            } else {
                setMessage('Error: invalid input, please use a valid email')
                setIsError(true)
            }

        } catch (err) {
            setMessage(`Error: Failed to join the newsletter`)
            console.log(`Error: ${err}`)
            setIsError(true)
        }
    }

    return (
        <>
            <Head>
                <title>Clonify</title>
                <meta name="description" content="Generated by create next app"/>
                <meta name="viewport" content="width=device-width, initial-scale=1"/>
                <link rel="icon" href="/favicon.ico"/>
                {/*change icon to clonify icon*/}
            </Head>
            <main>
                <NavBar/>
                <section className={styles.headerSection}>
                    <img src="/Paste%20image.jpg" alt=""/>
                    <div className={styles.block}>
                        <div className={styles.textBlock}>
                            <p>IKIGAI</p>
                            <h1>Leather bags worth hugging</h1>
                            <h5>Keep your everyday style chic and on-trend with
                                our selection 20+ styles to choose from.
                            </h5>
                            <Link href={'/'}>
                                <div className={styles.collectionButton}><h5>See Collection</h5></div>
                            </Link>
                        </div>
                    </div>
                </section>

                <section className={styles.logosSection}>
                    <img id={styles.arrow} src="/arrow_left.svg" alt=""/>
                    <div className={styles.logoGroup}>
                        <img src="/Elements/Logos.svg" alt=""/>
                        <img src="/Elements/Logos-1.svg" alt=""/>
                        <img src="/Elements/Logos-2.svg" alt=""/>
                        <img src="/Elements/Logos-3.svg" alt=""/>
                        <img src="/Elements/Logos-4.svg" alt=""/>
                        <img src="/Elements/Logos-5.svg" alt=""/>
                    </div>
                    <img id={styles.arrow} src="/arrow_right.svg" alt=""/>
                </section>

                <section className={styles.bannerGridsection}>
                    <div className={styles.card}>
                        <img src="/banner_pics/bannerimg1.jpg" alt=""/>
                        <div className={styles.text}>
                            <p>Featured</p>
                            <h4>Nairo Series</h4>
                        </div>
                    </div>

                    <div className={styles.card}>
                        <img src="/banner_pics/bannerimg2.jpg" alt=""/>
                        <div className={styles.text}>
                            <p>New</p>
                            <h4>Kensho Series</h4>
                        </div>
                    </div>

                    <div className={styles.card}>
                        <img src="/banner_pics/bannerimg3.jpg" alt=""/>
                        <div className={styles.text}>
                            <p>Handmade</p>
                            <h4>Atarashi Series</h4>
                        </div>
                    </div>
                </section>

                <section className={styles.discountSection}>
                    <img src="/discount_img.jpg" alt=""/>
                    <div className={styles.block}>
                        <div className={styles.textBlock}>
                            <p>EXCLUSIVE</p>
                            <h1>50% OFF</h1>
                            <h5>Sed ut perspiciatis unde omnis iste natus error sit
                                voluptatem accusantium doloremque
                            </h5>
                            <h3>05d : 11h : 23m : 02s</h3>
                            <Link href={'/'}>
                                <div className={styles.shopNowbutton}><p>Show Now</p></div>
                            </Link>
                        </div>
                    </div>
                </section>

                <section className={styles.ctaSection}>

                    <h2>Join our newsletter</h2>
                    <h5>Enjoy big discounts and latest updates right to your inbox</h5>
                    <div>
                        <input onChange={(e) => setEmailInput(e.target.value)} placeholder={'Your Email'} value={emailInput} type="email"/>
                        <button className={styles.signUpButton} onClick={handleJoinNewsletter}>Signup</button>
                    </div>
                    <br/>
                    <p className={isError ? styles.messageError : styles.messageSuccess}>{message}</p>
                </section>

                <section className={styles.exquisiteSection}>
                    <picture>
                        <source media="(min-width:801px)" srcSet="/Elements/exquisite_img.jpg"/>
                        <img src="/Elements/exquisite_img_mobile.jpg" alt=""/>
                    </picture>
                    <div className={styles.textBlock}>
                        <h2>Exquisite Craftsmanship</h2>
                        <h5>Phosfluor escently engage wordlwide methodologies with web-enabled process-centric
                            technology </h5>
                        <div className={styles.learnMore}>
                            <Link href={'/'}><p>Learn more</p></Link>
                        </div>
                    </div>
                </section>
                <Footer/>
            </main>
        </>
    )
}

